Packager: Igor Vlasenko <viy@altlinux.ru>
BuildRequires: /proc
BuildRequires: jpackage-compat
# Copyright (c) 2000-2008, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define namedversion 1.5.6
%define bname groovy

Name:           groovy15
Summary:        Groovy scripting language
Url:            http://groovy.codehaus.org/
Version:        1.5.6
Release:        alt1_2jpp5
Epoch:          0
License:        Apache Software License 2.0
Group:          Development/Java
Source0:        http://dist.groovy.codehaus.org/distributions/groovy-src-1.5.6.zip

Source1:        http://repository.codehaus.org/org/codehaus/groovy/groovy-all/1.5.6/groovy-all-1.5.6.pom
Source2:        http://repository.codehaus.org/org/codehaus/groovy/groovy-all-minimal/1.5.6/groovy-all-minimal-1.5.6.pom

Patch0:         groovy15-build-maven.patch
Patch1:         groovy15-build.patch

BuildRequires: jpackage-utils >= 0:1.7.5

BuildRequires: ant >= 0:1.6.5
BuildRequires: ant-antlr
BuildRequires: ant-junit
BuildRequires: ant-trax
BuildRequires: antlr
BuildRequires: checkstyle
BuildRequires: cobertura
BuildRequires: junit
BuildRequires: xmlunit

BuildRequires: asm2 >= 0:2.2
BuildRequires: bsf
BuildRequires: cglib >= 0:2.1.3
BuildRequires: hsqldb
BuildRequires: jakarta-commons-beanutils
BuildRequires: jakarta-commons-cli
BuildRequires: jakarta-commons-codec
BuildRequires: jakarta-commons-collections
BuildRequires: jakarta-commons-httpclient
BuildRequires: jakarta-commons-lang
BuildRequires: jakarta-commons-logging
BuildRequires: jakarta-oro
BuildRequires: jarjar
BuildRequires: jline
BuildRequires: jmock
BuildRequires: jsp_2_0_api
BuildRequires: lucene1
BuildRequires: mockobjects
BuildRequires: mx4j
BuildRequires: openejb1
BuildRequires: qdox
BuildRequires: servlet_2_4_api
BuildRequires: xpp3-minimal
BuildRequires: xstream

#
Requires: ant
Requires: ant-junit
Requires: ant-trax
Requires: antlr
Requires: asm2
Requires: bsf
Requires: jakarta-commons-cli
Requires: jakarta-commons-logging
Requires: jarjar
Requires: jline
Requires: jsp_2_0_api
Requires: junit
Requires: mockobjects
Requires: mx4j
Requires: servlet_2_4_api
Requires: xpp3-minimal
Requires: xstream

Requires(post): jpackage-utils >= 0:1.7.5
Requires(postun): jpackage-utils >= 0:1.7.5
BuildArch:      noarch


%description
Groovy is a new agile dynamic language for the JVM 
combining lots of great features from languages like 
Python, Ruby and Smalltalk and making them available 
to the Java developers using a Java-like syntax.
Groovy is designed to help you get things done on the 
Java platform in a quicker, more concise and fun way - 
bringing the power of Python and Ruby inside the Java 
platform. 
Groovy can be used as an alternative compiler to javac 
to generate standard Java bytecode to be used by any 
Java project or it can be used dynamically as an 
alternative language such as for scripting Java objects, 
templating or writing unit test cases.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
Javadoc for %{name}.

%prep
%setup -q -n groovy-%{version}
chmod -R go=u-w *
#find . -name "*.jar" -exec rm -f {} \;
#for j in $(find . -name "*.jar"); do
#    mv $j $j.no
#done

%patch0 -b .sav0
%patch1 -b .sav1

mkdir -p target/lib/compile
pushd target/lib/compile
#target/lib/compile/ant-1.7.0.jar
ln -sf $(build-classpath ant)
#target/lib/compile/antlr-2.7.6.jar
ln -sf $(build-classpath antlr)
#target/lib/compile/asm-2.2.jar
ln -sf $(build-classpath asm2/asm2)
ln -sf $(build-classpath asm2/asm2-commons)
#target/lib/compile/asm-analysis-2.2.jar
ln -sf $(build-classpath asm2/asm2-analysis)
#target/lib/compile/asm-tree-2.2.jar
ln -sf $(build-classpath asm2/asm2-tree)
#target/lib/compile/asm-util-2.2.jar
ln -sf $(build-classpath asm2/asm2-util)
#target/lib/compile/bsf-2.4.0.jar
ln -sf $(build-classpath bsf)
#target/lib/compile/commons-cli-1.0.jar
ln -sf $(build-classpath commons-cli)
#target/lib/compile/jline-0.9.94.jar
ln -sf $(build-classpath jline)
#target/lib/compile/jsp-api-2.0.jar
ln -sf $(build-classpath jsp_2_0_api)
#target/lib/compile/junit-3.8.2.jar
ln -sf $(build-classpath junit)
#target/lib/compile/mockobjects-core-0.09.jar
ln -sf $(build-classpath mockobjects-core)
#target/lib/compile/mx4j-3.0.2.jar
# ln -sf $(build-classpath mx4j/mx4j)
#target/lib/compile/servlet-api-2.4.jar
ln -sf $(build-classpath servlet_2_4_api)
#target/lib/compile/xpp3_min-1.1.3.4.O.jar
ln -sf $(build-classpath xpp3-minimal)
#target/lib/compile/xstream-1.2.2.jar
ln -sf $(build-classpath xstream)
popd
mkdir -p target/lib/examples
pushd target/lib/examples
#target/lib/examples/commons-httpclient-3.0.1.jar
ln -sf $(build-classpath commons-httpclient)
#target/lib/examples/lucene-1.4.3.jar
ln -sf $(build-classpath lucene)
#target/lib/examples/openejb-loader-1.0.jar
ln -sf $(build-classpath openejb1/loader)
popd
mkdir -p target/lib/runtime
pushd target/lib/runtime
#target/lib/runtime/ant-1.7.0.jar
ln -sf $(build-classpath ant)
#target/lib/runtime/ant-junit-1.7.0.jar
ln -sf $(build-classpath ant/ant-junit)
#target/lib/runtime/ant-launcher-1.7.0.jar
ln -sf $(build-classpath ant-launcher)
#target/lib/runtime/antlr-2.7.6.jar
ln -sf $(build-classpath antlr)
#target/lib/runtime/asm-2.2.jar
ln -sf $(build-classpath asm2/asm2)
ln -sf $(build-classpath asm2/asm2-commons)
#target/lib/runtime/asm-analysis-2.2.jar
ln -sf $(build-classpath asm2/asm2-analysis)
#target/lib/runtime/asm-tree-2.2.jar
ln -sf $(build-classpath asm2/asm2-tree)
#target/lib/runtime/asm-util-2.2.jar
ln -sf $(build-classpath asm2/asm2-util)
#target/lib/runtime/bsf-2.4.0.jar
ln -sf $(build-classpath bsf)
#target/lib/runtime/commons-cli-1.0.jar
ln -sf $(build-classpath commons-cli)
#target/lib/runtime/commons-logging-1.1.jar
ln -sf $(build-classpath commons-logging)
#target/lib/runtime/jline-0.9.94.jar
ln -sf $(build-classpath jline)
#target/lib/runtime/jsp-api-2.0.jar
ln -sf $(build-classpath jsp_2_0_api)
#target/lib/runtime/junit-3.8.2.jar
ln -sf $(build-classpath junit)
#target/lib/runtime/mockobjects-core-0.09.jar
ln -sf $(build-classpath mockobjects-core)
#target/lib/runtime/mx4j-3.0.2.jar
ln -sf $(build-classpath mx4j/mx4j)
#target/lib/runtime/servlet-api-2.4.jar
ln -sf $(build-classpath servlet_2_4_api)
#target/lib/runtime/xpp3_min-1.1.3.4.O.jar
ln -sf $(build-classpath xpp3-minimal)
#target/lib/runtime/xstream-1.2.2.jar
ln -sf $(build-classpath xstream)
popd
mkdir -p target/lib/test
pushd target/lib/test
#target/lib/test/ant-1.7.0.jar
ln -sf $(build-classpath ant)
#target/lib/test/ant-junit-1.7.0.jar
ln -sf $(build-classpath ant/ant-junit)
#target/lib/test/ant-launcher-1.7.0.jar
ln -sf $(build-classpath ant-launcher)
#target/lib/test/antlr-2.7.6.jar
ln -sf $(build-classpath antlr)
#target/lib/test/asm-2.2.jar
ln -sf $(build-classpath asm2/asm2)
ln -sf $(build-classpath asm2/asm2-commons)
#target/lib/test/asm-analysis-2.2.jar
ln -sf $(build-classpath asm2/asm2-analysis)
#target/lib/test/asm-attrs-2.2.jar
ln -sf $(build-classpath asm2/asm2-attrs)
#target/lib/test/asm-tree-2.2.jar
ln -sf $(build-classpath asm2/asm2-tree)
#target/lib/test/asm-util-2.2.jar
ln -sf $(build-classpath asm2/asm2-util)
#target/lib/test/bsf-2.4.0.jar
ln -sf $(build-classpath bsf)
#target/lib/test/cglib-nodep-2.1_3.jar
ln -sf $(build-classpath cglib)
#target/lib/test/commons-cli-1.0.jar
ln -sf $(build-classpath commons-cli)
#target/lib/test/commons-logging-1.1.jar
ln -sf $(build-classpath commons-logging)
#target/lib/test/hsqldb-1.8.0.7.jar
ln -sf $(build-classpath hsqldb)
#target/lib/test/jline-0.9.94.jar
ln -sf $(build-classpath jline)
#target/lib/test/jmock-1.2.0.jar
ln -sf $(build-classpath jmock)
#target/lib/test/jmock-cglib-1.2.0.jar
ln -sf $(build-classpath jmock-cglib)
#target/lib/test/jsp-api-2.0.jar
ln -sf $(build-classpath jsp_2_0_api)
#target/lib/test/junit-3.8.2.jar
ln -sf $(build-classpath junit)
#target/lib/test/mockobjects-core-0.09.jar
ln -sf $(build-classpath mockobjects-core)
#target/lib/test/mx4j-3.0.2.jar
ln -sf $(build-classpath mx4j/mx4j)
#target/lib/test/servlet-api-2.4.jar
ln -sf $(build-classpath servlet_2_4_api)
#target/lib/test/xmlunit-1.1.jar
ln -sf $(build-classpath xmlunit)
#target/lib/test/xpp3_min-1.1.3.4.O.jar
ln -sf $(build-classpath xpp3-minimal)
#target/lib/test/xstream-1.2.2.jar
ln -sf $(build-classpath xstream)
popd
mkdir -p target/lib/tools
pushd target/lib/tools
#target/lib/tools/antlr-2.7.6.jar
ln -sf $(build-classpath antlr)
#target/lib/tools/asm-2.2.1.jar
ln -sf $(build-classpath asm2/asm2)
ln -sf $(build-classpath asm2/asm2-commons)
#target/lib/tools/checkstyle-4.3.jar
ln -sf $(build-classpath checkstyle)
#target/lib/tools/cobertura-1.8.jar
ln -sf $(build-classpath cobertura)
#target/lib/tools/commons-beanutils-core-1.7.0.jar
ln -sf $(build-classpath commons-beanutils-core)
#target/lib/tools/commons-cli-1.0.jar
ln -sf $(build-classpath commons-cli)
#target/lib/tools/commons-collections-2.1.jar
ln -sf $(build-classpath commons-collections)
#target/lib/tools/commons-lang-1.0.jar
ln -sf $(build-classpath commons-lang)
#target/lib/tools/commons-logging-1.0.3.jar
ln -sf $(build-classpath commons-logging)
#target/lib/tools/jarjar-0.6.jar
#########################ln -sf $(build-classpath jarjar)
#target/lib/tools/log4j-1.2.9.jar
ln -sf $(build-classpath log4j)
#target/lib/tools/oro-2.0.8.jar
ln -sf $(build-classpath oro)
#target/lib/tools/qdox-1.6.1.jar
ln -sf $(build-classpath qdox)
#target/lib/tools/simian-2.2.4.jar
popd

%build
export ANT_OPTS="-Xmx512m"
export OPT_JAR_LIST="ant/ant-antlr ant/ant-trax ant/ant-junit jarjar"
ant install doc

%install
# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -m 644 target/dist/%{bname}-%{namedversion}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
install -m 644 target/dist/%{bname}-all-%{namedversion}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}-all-%{version}.jar
install -m 644 target/dist/%{bname}-all-minimal-%{namedversion}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}-all-minimal-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# poms and depmap frags
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -m 644 pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom
%add_to_maven_depmap org.codehaus.groovy groovy %{namedversion} JPP %{name}
install -m 644 %{SOURCE1} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}-all.pom
%add_to_maven_depmap org.codehaus.groovy groovy-all %{namedversion} JPP %{name}-all
install -m 644 %{SOURCE2} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}-all-minimal.pom
%add_to_maven_depmap org.codehaus.groovy groovy-all-minimal %{namedversion} JPP %{name}-all-minimal

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/html/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

# bin
install -d -m 755 $RPM_BUILD_ROOT%{_bindir}
install -m 755 target/install/bin/groovy $RPM_BUILD_ROOT%{_bindir}/groovy15
install -m 755 target/install/bin/groovyc $RPM_BUILD_ROOT%{_bindir}/groovyc15
install -m 755 target/install/bin/groovyConsole $RPM_BUILD_ROOT%{_bindir}/groovyConsole15
install -m 755 target/install/bin/groovysh $RPM_BUILD_ROOT%{_bindir}/groovysh15
install -m 755 target/install/bin/java2groovy $RPM_BUILD_ROOT%{_bindir}/java2groovy15
install -m 755 target/install/bin/startGroovy $RPM_BUILD_ROOT%{_bindir}/startGroovy15

# conf
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/conf
install -m 644 target/install/conf/* $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/conf

# lib
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/embeddable
pushd $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/embeddable
ln -sf %{_javadir}/groovy-all.jar
popd

# lib
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/lib
pushd $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/lib
build-jar-repository . \
ant \
ant/ant-junit \
ant-launcher \
antlr \
asm2/asm2-analysis \
asm2/asm2 \
asm2/asm2-tree \
asm2/asm2-util \
bsf \
commons-cli \
commons-logging \
jline \
jsp_2_0_api \
junit \
mockobjects-core \
mx4j/mx4j \
servlet_2_4_api \
xpp3 \
xstream \

ln -sf %{_javadir}/groovy15.jar
popd

%preun
if [ "$1" = "0" ]; then
  rm %{_datadir}/%{name}-%{version}/lib/*.jar
fi

%pre
rm -f %{_datadir}/%{name}-%{version}/lib/*

%post
rebuild-jar-repository %{_datadir}/%{name}-%{version}/lib
:

%files
%doc LICENSE.txt
%{_javadir}/*
%attr(755, root, root) %{_bindir}/*
%{_datadir}/%{name}-%{version}
%{_datadir}/maven2
%{_mavendepmapfragdir}

%files javadoc
%{_javadocdir}/%{name}-%{version}
%doc %{_javadocdir}/%{name}

%changelog
* Tue Mar 03 2009 Igor Vlasenko <viy@altlinux.ru> 0:1.5.6-alt1_2jpp5
- new version

